package org.sadigit.adapter;

import org.locationtech.jts.geom.Point;
import org.locationtech.jts.io.WKTReader;

import jakarta.json.bind.adapter.JsonbAdapter;

public class PointAdapter implements JsonbAdapter<Point, String> {

    @Override
    public String adaptToJson(Point point) throws Exception {
        // Serialize the Point object to a string representation
        return point.toText();
    }

    @Override
    public Point adaptFromJson(String pointString) throws Exception {
        // Deserialize the string representation to a Point object
        return (Point) new WKTReader().read(pointString);
    }
}
