package org.sadigit.entity;

import lombok.Getter;
import lombok.Setter;

import java.math.BigInteger;
import java.sql.Timestamp;
import org.hibernate.annotations.Immutable;
import org.sadigit.entity.referensi.Posko;
import org.sadigit.entity.referensi.Regional;
import org.sadigit.entity.referensi.Uid;
import org.sadigit.entity.referensi.Ulp;
import org.sadigit.entity.referensi.Up3;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Getter
@Setter
@Immutable
@Table(name = "appuser", schema = "apkt_transactional")
public class AppUser extends PanacheEntityBase {

    @Id
    @Column(name = "userid", nullable = false)
    private BigInteger userId;

    @Column(name = "username", length = 200)
    private String username;

    @Column(name = "employeename", length = 200)
    private String employeeName;

    @Column(name = "nip", length = 200)
    private String nip;

    @Column(name = "password", length = 200)
    private String password;

    @Column(name = "address", length = 4000)
    private String address;

    @Column(name = "phone", length = 20)
    private String phone;

    @Column(name = "mobile", length = 20)
    private String mobile;

    @Column(name = "email", length = 200)
    private String email;

    @ManyToOne(optional = false, fetch = FetchType.EAGER)
    @JoinColumn(name = "positionid", referencedColumnName = "id")
    private Position position;

    @Column(name = "unitid")
    private Long unitId;

    @Column(name = "isactive", length = 255)
    private String isActive;

    @Column(name = "islogin", length = 255)
    private String isLogin;

    @Column(name = "passwordchangedate")
    private Timestamp passwordChangeDate;

    @Column(name = "createdate")
    private Timestamp createDate;

    @Column(name = "createby")
    private Long createBy;

    @Column(name = "updatedate")
    private Timestamp updateDate;

    @Column(name = "updateby")
    private Long updateBy;

    @Column(name = "pukid")
    private Long pukId;

    @Column(name = "pukanswer", length = 200)
    private String pukAnswer;

    @Column(name = "defaulttab")
    private Long defaultTab;

    @Column(name = "no_imei", length = 50)
    private String noImei;

    @Column(name = "domain", length = 50)
    private String domain;

    @Column(name = "picture")
    private String picture;

    @ManyToOne(optional = true, fetch = FetchType.EAGER)
    @JoinColumn(name = "unitId", referencedColumnName = "id", insertable = false, updatable = false, nullable = true)
    private Ulp ulp;

    @ManyToOne(optional = true, fetch = FetchType.EAGER)
    @JoinColumn(name = "unitId", referencedColumnName = "id", insertable = false, updatable = false, nullable = true)
    private Regional regional;

    @ManyToOne(optional = true, fetch = FetchType.EAGER)
    @JoinColumn(name = "unitId", referencedColumnName = "id", insertable = false, updatable = false, nullable = true)
    private Uid uid;

    @ManyToOne(optional = true, fetch = FetchType.EAGER)
    @JoinColumn(name = "unitId", referencedColumnName = "id", insertable = false, updatable = false, nullable = true)
    private Up3 up3;

    @ManyToOne(optional = true, fetch = FetchType.EAGER)
    @JoinColumn(name = "unitId", referencedColumnName = "id", insertable = false, updatable = false, nullable = true)
    private Posko posko;

}
