package org.sadigit.entity.referensi;

import java.sql.Timestamp;
import org.hibernate.annotations.Immutable;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import lombok.Getter;
import lombok.Setter;
import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Getter
@Setter
@Immutable
@Table(name = "master_ulp", schema = "apkt_transactional")
public class Ulp extends PanacheEntity {

    @Column(name = "id")
    private Long id;

    @Column(name = "id_up3")
    private Long idUp3;

    @Column(name = "nama")
    private String nama;

    @Column(name = "kode", nullable = false)
    private String kode;

    @Column(name = "alamat")
    private String alamat;

    @Column(name = "created_date")
    private Timestamp created_date;

    @Column(name = "created_by")
    private Long created_by;

    @Column(name = "updated_date")
    private Timestamp updated_date;

    @Column(name = "updated_by")
    private Long updated_by;

    @Column(name = "telepon")
    private String telepon;

    @Column(name = "aktif", nullable = true)
    private Boolean aktif;

    @Column(name = "city")
    private String city;

    @Column(name = "zip")
    private String zip;

    @Column(name = "mobile")
    private String mobile;

    @Column(name = "fax")
    private String fax;

    @Column(name = "email")
    private String email;

    @ManyToOne(fetch = FetchType.EAGER, optional = false, cascade = CascadeType.ALL)
    @JoinColumn(name = "id_up3", referencedColumnName = "id", insertable = false, updatable = false, nullable = true)
    private Up3 up3;
}
