package org.sadigit.entity.referensi;

import lombok.Getter;
import lombok.Setter;

import java.time.Instant;
import org.hibernate.annotations.Immutable;
import org.locationtech.jts.geom.Geometry;
import org.sadigit.adapter.GeometryAdapter;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.json.bind.annotation.JsonbTypeAdapter;
import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Getter
@Setter
@Immutable
@Table(name = "master_up3", schema = "apkt_transactional")
public class Up3 extends PanacheEntityBase {
    @Id
    @Column(name = "id")
    public Long id;

    @Column(name = "id_uid", nullable = false)
    public Long idUid;

    @Column(name = "nama", nullable = false)
    public String nama;

    @Column(name = "kode", nullable = false)
    public String kode;

    @Column(name = "alamat", nullable = false)
    public String alamat;

    @Column(name = "location")
    public String location;

    @Column(name = "created_date", nullable = false)
    public Instant createdDate;

    @Column(name = "created_by", nullable = false)
    public Long createdBy;

    @Column(name = "updated_date")
    public Instant updatedDate;

    @Column(name = "updated_by")
    public Long updatedBy;

    @Column(name = "telepon", nullable = false)
    public String telepon;

    @Column(name = "aktif", nullable = false)
    public Boolean aktif;

    @JsonbTypeAdapter(GeometryAdapter.class)
    @Column(name = "geom_point", columnDefinition = "geometry(Point,4326)")
    private Geometry geomPoint;
    @Column(name = "city")
    public String city;

    @Column(name = "zip")
    public String zip;

    @Column(name = "fax")
    public String fax;

    @Column(name = "email")
    public String email;

    @ManyToOne(fetch = FetchType.EAGER, optional = false, cascade = CascadeType.ALL)
    @JoinColumn(name = "id_uid", referencedColumnName = "id", insertable = false, updatable = false)
    public Uid uid;
}
