package org.sadigit.entity.saidisaifi.masterJaringan;

import java.sql.Timestamp;

import org.hibernate.annotations.Immutable;
import org.locationtech.jts.geom.Geometry;
import org.sadigit.adapter.GeometryAdapter;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import jakarta.json.bind.annotation.JsonbTypeAdapter;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "master_gardu_distribusi", schema = "apkt_transactional")
@Immutable
public class MasterGarduDistribusi extends PanacheEntity {
    @Column(name = "id")
    private Long id;

    @Column(name = "id_feeder", nullable = false)
    private Long idFeeder;

    @Column(name = "kode", nullable = false)
    private String kode;

    @Column(name = "nomor", nullable = false)
    private String nomor;

    @Column(name = "nama", nullable = false)
    private String nama;

    @Column(name = "alamat", nullable = false)
    private String alamat;

    @Column(name = "area_layanan", nullable = false)
    private String areaLayanan;

    @Column(name = "phasa", nullable = false)
    private String phasa;

    @Column(name = "jumlah_jurusan", nullable = false)
    private String jumlahJurusan;

    @Column(name = "jumlah_daya", nullable = false)
    private String jumlahDaya;

    @Column(name = "jumlah_pelanggan", nullable = false)
    private String jumlahPelanggan;

    @Column(name = "created_date")
    private Timestamp createdDate;

    @Column(name = "created_by")
    private Long createdBy;

    @Column(name = "updated_date")
    private Timestamp updatedDate;

    @Column(name = "updated_by")
    private Long updatedBy;

    @JsonbTypeAdapter(GeometryAdapter.class)
    @Column(name = "point", columnDefinition = "geometry(Point,4326)")
    private Geometry point;

    @Column(name = "status")
    private String status;

    @Column(name = "no_tiang")
    private String noTiang;

    @Column(name = "jenis")
    private String jenis;

    @Column(name = "konstruksi")
    private String konstruksi;

    @Column(name = "telepon")
    private String telepon;

    @Column(name = "kapasitas")
    private Long kapasitas;

    @Column(name = "sisipan")
    private Boolean sisipan;

    @Column(name = "deskripsi")
    private String deskripsi;
}
