package org.sadigit.entity.saidisaifi.masterJaringan;

import java.sql.Timestamp;

import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.Immutable;
import org.hibernate.annotations.UpdateTimestamp;
import org.locationtech.jts.geom.Geometry;
import org.sadigit.adapter.GeometryAdapter;
import org.sadigit.entity.referensi.Up3;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.json.bind.annotation.JsonbTypeAdapter;
import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "master_gardu_induk", schema = "apkt_transactional")
@Immutable
public class MasterGarduInduk extends PanacheEntityBase {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @ManyToOne(fetch = FetchType.EAGER, optional = false, cascade = CascadeType.ALL)
    @JoinColumn(name = "id_up3", referencedColumnName = "id")
    private Up3 up3;

    private String kode;

    private String area;

    private String nama;

    private String alamat;

    @JsonbTypeAdapter(GeometryAdapter.class)
    @Column(name = "lokasi", columnDefinition = "geometry(Point,4326)")
    private Geometry lokasi;

    @CreationTimestamp
    @Column(name = "created_date")
    private Timestamp created_date;

    @Column(name = "created_by")
    private Long created_by;

    @UpdateTimestamp
    @Column(name = "updated_date")
    private Timestamp updated_date;

    @Column(name = "updated_by")
    private Long updated_by;

    @Column(name = "status")
    private String status;


}
