package org.sadigit.entity.saidisaifi.masterJaringan;

import java.time.LocalDateTime;

import org.hibernate.annotations.Immutable;
import org.locationtech.jts.geom.Geometry;
import org.sadigit.adapter.GeometryAdapter;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import jakarta.json.bind.annotation.JsonbTypeAdapter;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "master_lateral", schema = "apkt_transactional")
@Immutable
public class MasterLateral extends PanacheEntity {
    @Column(name = "id", nullable = false)
    private Long id;

    @ManyToOne
    @JoinColumn(name = "id_segment", nullable = false)
    private MasterSegment masterSegment;

    @Column(name = "kode", nullable = false)
    private String kode;

    @Column(name = "rayon", nullable = false)
    private String rayon;

    @Column(name = "keterangan")
    private String keterangan;

    @Column(name = "alamat", nullable = false)
    private String alamat;

    @Column(name = "created_date")
    private LocalDateTime createdDate;

    @Column(name = "created_by")
    private Long createdBy;

    @Column(name = "updated_date")
    private LocalDateTime updatedDate;

    @Column(name = "updated_by")
    private Long updatedBy;

    @JsonbTypeAdapter(GeometryAdapter.class)
    @Column(name = "point", columnDefinition = "geometry(Point,4326)")
    private Geometry point;

}
