package org.sadigit.entity.saidisaifi.masterJaringan;

import java.time.LocalDateTime;

import org.hibernate.annotations.Immutable;
import org.locationtech.jts.geom.Geometry;
import org.sadigit.adapter.GeometryAdapter;
import org.sadigit.entity.referensi.Ulp;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import jakarta.json.bind.annotation.JsonbTypeAdapter;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "master_switch", schema = "apkt_transactional")
@Immutable
public class MasterSwitch extends PanacheEntity {
    @Column(name = "id", nullable = false)
    private Long id;

    @ManyToOne
    @JoinColumn(name = "id_ulp", nullable = false)
    private Ulp ulp;

    @Column(name = "tipe", nullable = false)
    private String tipe;

    @Column(name = "created_date")
    private LocalDateTime created_date;

    @Column(name = "created_by")
    private Long created_by;

    @Column(name = "updated_date")
    private LocalDateTime updatedDate;

    @Column(name = "updated_by")
    private Long updated_by;

    @JsonbTypeAdapter(GeometryAdapter.class)
    @Column(name = "point", columnDefinition = "geometry(Point,4326)")
    private Geometry point;

}
