package org.sadigit.entity.transaksi;

import org.hibernate.annotations.Immutable;
import org.sadigit.entity.SessionUser;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.time.LocalDateTime;

@Entity
@Setter
@Getter
@Table(name = "gangguan_tm_transaksi", schema = "apkt_transactional")
@Immutable
public class GangguanTMTransaksi extends PanacheEntityBase implements Serializable {
    
    @Id
    @SequenceGenerator(name = "gangguan_tm_transaksi_seq", sequenceName = "apkt_transactional.gangguan_tm_transaksi_seq", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "gangguan_tm_transaksi_seq")
    @Column(name = "id")
    private Long id;

    @ManyToOne
    @JoinColumn(name = "id_gangguan_tm", nullable = false)
    private GangguanTm gangguanTm;

    @Column(name = "jenis", nullable = false)
    private String jenis;

    @Column(name = "waktu")
    private LocalDateTime waktu;

    @Column(name = "created_date", nullable = false)
    private LocalDateTime created_date;

    @Column(name = "created_by", nullable = false)
    private Long created_by;

    @Column(name = "notif_flag", nullable = true)
    private Boolean notif_flag;

    @Column(name = "waktu_read")
    private LocalDateTime waktu_read;

    @ManyToOne
    @JoinColumn(name = "id_session")
    private SessionUser session;

    // Constructors, getters, setters, etc.
}