package org.sadigit.entity.transaksi;

import java.sql.Timestamp;
import java.time.LocalDateTime;

import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.Immutable;
import org.hibernate.annotations.UpdateTimestamp;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "gangguan_tm", schema = "apkt_transactional")
@Immutable
public class GangguanTeganganMenengah extends PanacheEntity {
    @Column(name = "id")
    private Long id;

    @Column(name = "prioritas")
    private String prioritas;

    @Column(name = "id_ulp")
    private Long idUlp;

    @Column(name = "perkiraan_area_padam")
    private String perkiraanAreaPadam;

    @Column(name = "estimasi_padam")
    private String estimasiPadam;

    @Column(name = "titik_gangguan")
    private String titikGangguan;

    @Column(name = "no_tiang")
    private String noTiang;

    @Column(name = "nama_asset")
    private String namaAsset;

    @Column(name = "waktu_catat")
    private LocalDateTime waktuCatat;

    @Column(name = "waktu_gangguan")
    private LocalDateTime waktuGangguan;

    @Column(name = "waktu_nyala")
    private LocalDateTime waktuNyala;

    @Column(name = "status_akhir")
    private String statusAkhir;

    @Column(name = "jumlah_pelanggan")
    private Long jumlahPelanggan;

    @Column(name = "ampere")
    private Long ampere;

    @Column(name = "cuaca")
    private String cuaca;

    @Column(name = "no_gangguan_tm")
    private String noGangguanTm;

    @Column(name = "keterangan", length = 4000)
    private String keterangan;

    @CreationTimestamp
    @Column(name = "created_date")
    private Timestamp createdDate;

    @Column(name = "created_by")
    private Long createdBy;

    @UpdateTimestamp
    @Column(name = "updated_date")
    private Timestamp updatedDate;

    @Column(name = "updated_by")
    private Long updatedBy;

    @Column(name = "id_regu")
    private Long idRegu;

    @Column(name = "alasan")
    private String alasan;
}
