package org.sadigit.entity.transaksi;

import org.hibernate.annotations.Immutable;
import org.sadigit.entity.SessionUser;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

import java.time.LocalDateTime;

@Entity
@Setter
@Getter
@Table(name = "keluhan_transaksi", schema = "apkt_transactional")
@Immutable
public class KeluhanTransaksi extends PanacheEntityBase {

    @Id
    @SequenceGenerator(name = "keluhan_transaksi_seq", sequenceName = "apkt_transactional.keluhan_transaksi_seq", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "keluhan_transaksi_seq")
    @Column(name = "id")
    private Long id;

    @ManyToOne
    @JoinColumn(name = "id_keluhan", nullable = false)
    private Keluhan keluhan;

    @Column(name = "jenis", nullable = false)
    private String jenis;

    @Column(name = "waktu")
    private LocalDateTime waktu;

    @Column(name = "created_date", nullable = false)
    private LocalDateTime created_date;

    @Column(name = "created_by", nullable = false)
    private Long created_by;

    @ManyToOne
    @JoinColumn(name = "id_session")
    private SessionUser session;

    @Column(name = "notif_flag", nullable = true)
    private Boolean notif_flag;

    // Constructors, getters, setters, etc.
}