package org.sadigit.entity.transaksi;

import java.time.LocalDateTime;

import org.hibernate.annotations.Immutable;
import org.locationtech.jts.geom.Geometry;
import org.sadigit.adapter.GeometryAdapter;
import org.sadigit.entity.referensi.Posko;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import jakarta.json.bind.annotation.JsonbTypeAdapter;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "master_regu", schema = "apkt_transactional")
@Immutable
public class MasterRegu extends PanacheEntity {
    @Column(name = "id")
    private Long id;

    @ManyToOne(fetch = FetchType.EAGER, optional = false, cascade = CascadeType.ALL)
    @JoinColumn(name = "id_posko", referencedColumnName = "id")
    private Posko posko;

    @Column(name = "nama", nullable = false)
    private String nama;

    @Column(name = "kode", nullable = false)
    private String kode;

    @Column(name = "alamat", nullable = false)
    private String alamat;

    @Column(name = "telepon", nullable = false)
    private String telepon;

    @Column(name = "aktif", nullable = false)
    private boolean aktif;

    @JsonbTypeAdapter(GeometryAdapter.class)
    @Column(name = "lokasi", columnDefinition = "geometry(Point,4326)")
    private Geometry lokasi;

    @Column(name = "created_date")
    private LocalDateTime created_date;

    @Column(name = "created_by")
    private Long created_by;

    @Column(name = "updated_date")
    private LocalDateTime updated_date;

    @Column(name = "updated_by")
    private Long updated_by;

}
