package org.sadigit.entity.transaksi;

import java.time.LocalDateTime;

import org.hibernate.annotations.Immutable;
import org.sadigit.entity.referensi.Material;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "material_transaksi", schema = "apkt_transactional")
@Immutable
public class MaterialTransaksi extends PanacheEntity {
    private Long id;

    @ManyToOne
    @JoinColumn(name = "id_material", nullable = false)
    private Material material;

    private Long stok;
    private Long stokOs;

    @Enumerated(EnumType.STRING)
    @Column(nullable = false)
    private Tipe tipe;

    private String noDokumen;
    private LocalDateTime createdDate;
    private Long createdBy;
    private LocalDateTime updatedDate;
    private Long updatedBy;

    @ManyToOne
    @JoinColumn(name = "id_gangguan")
    private Gangguan gangguan;

    private Long id_gangguan_tm;

    public enum Tipe {
        IN("in"),
        OUT("out");

        private String value;

        Tipe(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return value;
        }
    }
}
