package org.sadigit.entity.transaksi;

import java.sql.Timestamp;

import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.Immutable;
import org.hibernate.annotations.UpdateTimestamp;
import org.locationtech.jts.geom.Geometry;
import org.sadigit.adapter.GeometryAdapter;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import jakarta.json.bind.annotation.JsonbTypeAdapter;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "pelanggan_no_meter", schema = "apkt_transactional")
@Immutable
public class PelangganNoMeter extends PanacheEntity {

    @Column(name = "id")
    private Long id;

    @Column(name = "nama", nullable = false)
    private String nama;

    @Column(name = "no_meter", nullable = false)
    private String no_meter;

    @Column(name = "alamat")
    private String alamat;

    @Column(name = "daya")
    private String daya;

    @JsonbTypeAdapter(GeometryAdapter.class)
    @Column(name = "lokasi", columnDefinition = "geometry(Point,4326)")
    private Geometry lokasi;

    @CreationTimestamp
    @Column(name = "created_date")
    private Timestamp created_date;

    @Column(name = "created_by")
    private Long created_by;
    @UpdateTimestamp
    @Column(name = "updated_date")
    private Timestamp updated_date;

    @Column(name = "updated_by")
    private Long updated_by;

    @Column(name = "id_pelanggan")
    private Long id_pelanggan;

    @Column(name = "telepon")
    private String telepon;

}
