package org.sadigit.model.request;

import java.util.Map;

import org.sadigit.control.exception.CustomException;
import org.sadigit.model.response.base.ResponseModel;

import jakarta.ws.rs.QueryParam;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.NonNull;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class GetCancelRequest {
    
    @NonNull
    @QueryParam("p_reportnumber")
    String p_reportnumber;

    @NonNull
    @QueryParam("p_userid")
    String p_userid;

    public void checkParameter() {
        if (this.p_reportnumber == null || this.p_reportnumber.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "No Laporan tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.p_userid == null || this.p_userid.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "User ID tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }
    }
}
