package org.sadigit.model.request;

import java.util.Map;

import org.sadigit.control.exception.CustomException;
import org.sadigit.model.response.base.ResponseModel;

import jakarta.ws.rs.QueryParam;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.NonNull;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class GetCttRequest {

    @NonNull
    @QueryParam("p_reportnumber")
    private String p_reportnumber;

    @NonNull
    @QueryParam("p_idpel")
    private String p_idpel;

    @QueryParam("p_kode08")
    private String p_kode08;

    @QueryParam("p_kode70")
    private String p_kode70;

    @QueryParam("p_kode71")
    private String p_kode71;

    @NonNull
    @QueryParam("p_kode41")
    private String p_kode41;

    @NonNull
    @QueryParam("p_kode44")
    private String p_kode44;

    @QueryParam("p_kode45")
    private String p_kode45;

    @QueryParam("p_kode46")
    private String p_kode46;

    @NonNull
    @QueryParam("p_kode37")
    private String p_kode37;

    @NonNull
    @QueryParam("p_kode47")
    private String p_kode47;

    public void checkParameter() {
        if (this.p_reportnumber == null || this.p_reportnumber.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "No Laporan tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.p_idpel == null || this.p_idpel.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "ID Pelanggan tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.p_kode41 == null || this.p_kode41.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "Kode 41 tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.p_kode44 == null || this.p_kode44.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "Kode 44 tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.p_kode37 == null || this.p_kode37.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "Kode 37 tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.p_kode47 == null || this.p_kode47.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "Kode 47 tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }
    }
}
