package org.sadigit.model.request;

import java.util.Map;

import org.sadigit.control.exception.CustomException;
import org.sadigit.model.response.base.ResponseModel;

import jakarta.ws.rs.QueryParam;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.NonNull;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class GetDataGarduV2Request {

    @NonNull
    @QueryParam("p_kode")
    Integer p_kode;

    @NonNull
    @QueryParam("p_jenis")
    Integer p_jenis;

    @QueryParam("p_jumlah")
    Integer p_jumlah;

    @QueryParam("p_nolaporan")
    String p_nolaporan;

    @QueryParam("p_kodegardu")
    String p_kodegardu;

    public void checkParameter() {
        if (this.p_kode == null) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "Kode tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.p_jenis == null) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "Jenis tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }
    }
}
