package org.sadigit.model.request;

import java.util.Map;

import org.sadigit.control.exception.CustomException;
import org.sadigit.model.response.base.ResponseModel;

import jakarta.ws.rs.QueryParam;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.NonNull;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class GetRatingPlgnRequest {

    @NonNull
    @QueryParam("p_reportnumber")
    String p_reportnumber;

    @NonNull
    @QueryParam("p_nilai")
    String p_nilai;

    @NonNull
    @QueryParam("p_keterangan")
    String p_keterangan;

    public void checkParameter() {
        if (this.p_reportnumber == null || this.p_reportnumber.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "No laporan tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.p_nilai == null || this.p_nilai.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "Nilai tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.p_keterangan == null || this.p_keterangan.isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of(
                            "msg", "Keterangan tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }
    }
}
