package org.sadigit.model.response;

import java.time.LocalDateTime;
import java.util.List;
import java.util.stream.Collectors;

import org.sadigit.entity.transaksi.Gangguan;
import org.sadigit.entity.transaksi.GangguanTransaksi;

import jakarta.json.bind.annotation.JsonbDateFormat;
import lombok.Builder;
import lombok.Data;

@Data
@Builder
public class DetailPengaduanFlowResponse {
    Long reguid;
    
    @JsonbDateFormat("yyyy/MM/dd HH:mm:ss")
    LocalDateTime updatedate;

    Double latitude;
    Double longitude;
    String status;
    String nama_regu;
    String reportnumber;
    
    public static DetailPengaduanFlowResponse fromGangguanTransaksi(GangguanTransaksi flow) {
        return DetailPengaduanFlowResponse.builder()
                .reguid(flow.getGangguan().getRegu() == null ? null :Long.valueOf(flow.getGangguan().getRegu().getId()))
                .updatedate(flow.getWaktu())
                .latitude(flow.getGangguan().getLokasi().getCoordinate().x)
                .longitude(flow.getGangguan().getLokasi().getCoordinate().y)
                .status(flow.getJenis())
                .nama_regu(flow.getGangguan().getRegu() == null ? null : flow.getGangguan().getRegu().getNama())
                .reportnumber(flow.getGangguan().getNo_laporan())
                .build();
    }

    public static List<DetailPengaduanFlowResponse> fromGangguan(Gangguan gangguan) {
        return gangguan.getGangguan_transaksi()
                .stream()
                .map(DetailPengaduanFlowResponse::fromGangguanTransaksi)
                .collect(Collectors.toList());
    }
}
