package org.sadigit.model.response;

import java.time.LocalDateTime;

import org.sadigit.entity.saidisaifi.masterJaringan.MasterGarduIndukTransaksi;

import jakarta.json.bind.annotation.JsonbDateFormat;
import lombok.Builder;
import lombok.Data;

@Data
@Builder
public class GarduPadamResponse {
    String kode_gardu;
    String no_laporan;
    String keterangan;
    String unitap;
    String unitupi;
    String unitup;

    @JsonbDateFormat("yyyy/MM/dd HH:mm")
    LocalDateTime tglcatat;

    @JsonbDateFormat("yyyy/MM/dd HH:mm")
    LocalDateTime tlg_padam;

    String latitude;
    String longitude;

    String status;
    String nama_gardu;

    public static GarduPadamResponse fromMasterGarduIndukTransaksi(MasterGarduIndukTransaksi masterGarduIndukTransaksi) {
        Double longitude = masterGarduIndukTransaksi.getGarduInduk().getLokasi().getCoordinate().x;
        Double latitude = masterGarduIndukTransaksi.getGarduInduk().getLokasi().getCoordinate().y;

        return GarduPadamResponse.builder()
                .kode_gardu(masterGarduIndukTransaksi.getGarduInduk().getKode())
                .no_laporan(masterGarduIndukTransaksi.getNo_laporan())
                .keterangan(masterGarduIndukTransaksi.getKeterangan())
                .unitap(null)
                .unitupi(null)
                .unitup(null)
                .tglcatat(masterGarduIndukTransaksi.getWaktu_catat())
                .tlg_padam(masterGarduIndukTransaksi.getWaktu_catat())
                .latitude(latitude.toString())
                .longitude(longitude.toString())
                .status(masterGarduIndukTransaksi.getStatus())
                .nama_gardu(masterGarduIndukTransaksi.getKeterangan())
                .build();
    }

}
