package org.sadigit.model.response;

import java.time.LocalDateTime;

import org.sadigit.entity.saidisaifi.masterJaringan.MasterGarduIndukTransaksi;

import jakarta.json.bind.annotation.JsonbDateFormat;
import lombok.Builder;
import lombok.Data;

@Data
@Builder
public class GarduRencanaResponse {
    String no_laporan;
    String unitupi;
    String unitap;
    String unitup;

    @JsonbDateFormat("yyyy/MM/dd HH:mm")
    LocalDateTime tglcatat;

    @JsonbDateFormat("yyyy/MM/dd HH:mm")
    LocalDateTime tgl_awal;

    String kode_gardu;
    String nama_gardu;
    String status;
    String keterangan;

    String longitude;
    String latitude;

    public static GarduRencanaResponse fromMasterGarduIndukTransaksi(MasterGarduIndukTransaksi masterGarduIndukTransaksi) {

        Double longitude = masterGarduIndukTransaksi.getGarduInduk().getLokasi().getCoordinate().x;
        Double latitude = masterGarduIndukTransaksi.getGarduInduk().getLokasi().getCoordinate().y;
        
        return GarduRencanaResponse.builder()
                .no_laporan(masterGarduIndukTransaksi.getNo_laporan())
                .unitupi(null)
                .unitap(null)
                .unitup(null)
                .tglcatat(masterGarduIndukTransaksi.getWaktu_catat())
                .tgl_awal(masterGarduIndukTransaksi.getWaktu_catat())
                .kode_gardu(masterGarduIndukTransaksi.getGarduInduk().getKode())
                .nama_gardu(masterGarduIndukTransaksi.getKeterangan())
                .status(masterGarduIndukTransaksi.getStatus())
                .keterangan(masterGarduIndukTransaksi.getKeterangan())
                .longitude(longitude.toString())
                .latitude(latitude.toString())
                .build();
    }
}
