package org.sadigit.model.response;

import java.time.LocalDateTime;
import org.sadigit.entity.transaksi.GangguanTMTransaksi;

import jakarta.json.bind.annotation.JsonbDateFormat;
import lombok.Builder;
import lombok.Data;

@Data
@Builder
public class GetDataResponse {
    String no_laporan;
    String keterangan;
    
    @JsonbDateFormat("yyyy/MM/dd hh:mm")
    LocalDateTime tlgflag;

    Integer flag;

    @JsonbDateFormat("yyyy/MM/dd hh:mm")
    LocalDateTime tglcatat;
    
    Integer jenis;
    String status;

    public static GetDataResponse fromGangguanTM(GangguanTMTransaksi gangguan) {
        int jenisGangguan = 0;
        String keterangan = "";
        switch(gangguan.getJenis().toLowerCase()) {
            case "selesai" : {
                jenisGangguan = 1;
                keterangan = "Status Pengaduan Selesai";
            } break;
            case "dalam perjalanan" : {
                jenisGangguan = 2;
                keterangan = "Petugas Dalam Perjalanan";
            } break;
            case "penugasan regu" : {
                jenisGangguan = 3;
                keterangan = "Penugasan Petugas Regu";
            } break;
            case "dalam pengerjaan" : {
                jenisGangguan = 4;
                keterangan = "Petugas Dalam Pengerjaan";
            } break;
            case "nyala" : {
                jenisGangguan = 5;
                keterangan = "Status Nyala";
            } break;
            case "nyala sementara" : {
                jenisGangguan = 6;
                keterangan = "Status Nyala Sementara";
            } break;
            default : {
                keterangan = gangguan.getJenis();
            }
        }

        return GetDataResponse.builder()
            .no_laporan(gangguan.getGangguanTm().getNoGangguanTm())
            .flag(gangguan.getNotif_flag() == null ? 0 : 1)
            .jenis(jenisGangguan)
            .keterangan(keterangan)
            .status(gangguan.getId().toString())
            // .tglcatat(BigDecimal.valueOf(gangguan.getCreated_date().toInstant(ZoneOffset.ofHours(7)).toEpochMilli()))
            .tglcatat(gangguan.getCreated_date())
            .tlgflag(gangguan.getWaktu_read())
            .build();
            
    }
}
