package org.sadigit.model.response;

import org.sadigit.entity.referensi.SubTipeKeluhan;
import lombok.Builder;
import lombok.Data;

/**
 * @author Tias Mardiansyah
 */

@Data
@Builder
public class GetMasterJenisPengaduanResponse {
    private String jenis_pengaduan;
    private Long kode_pengaduan;
    private Long subkode_pengaduan;
    private String subjenis_pengaduan;
    private String pengaduan;

    public static GetMasterJenisPengaduanResponse fromSubTipeKeluhan(SubTipeKeluhan tipeKeluhan) {

        String tipePengaduan = tipeKeluhan.getProjectid() == 1
            ? "GANGGUAN"
            : "KELUHAN";

        return GetMasterJenisPengaduanResponse.builder()
            .jenis_pengaduan(tipeKeluhan.getTipeKeluhan().getIssuetypename())
            .kode_pengaduan(tipeKeluhan.getTipeKeluhan().getIssuetypeid())
            .subkode_pengaduan(tipeKeluhan.getSubissuetypeid())
            .subjenis_pengaduan(tipeKeluhan.getSubissuetypename())
            .pengaduan(tipePengaduan)
            .build();
    }
}
