package org.sadigit.utils;

import org.locationtech.jts.geom.GeometryFactory;
import org.locationtech.jts.geom.Point;
import org.locationtech.jts.io.ParseException;
import org.locationtech.jts.io.WKTReader;
import org.locationtech.jts.io.WKTWriter;

public class GeomUtils {

    // Convert Point to WKT string
    public static String pointToWkt(Point point) {
        WKTWriter writer = new WKTWriter();
        return writer.write(point);
    }

    public static Point wktToPoint(String wkt, int srid) throws ParseException {
        GeometryFactory geometryFactory = new GeometryFactory();
        WKTReader reader = new WKTReader(geometryFactory);
        Point point = (Point) reader.read(wkt);
        point.setSRID(srid);
        return point;
    }

    public static Point wktToPoint(String lon, String lat, int srid) throws ParseException {
        String point = "POINT(" + lon + " " + lat + ")";
        return wktToPoint(point, srid);
    }
}
